package initHatenaIDnotation::Tags;

use strict;
use base qw( MT::Plugin );
use MT::Template::Context;

sub hatena_user_link{
		my ($str, $arg, $ctx) = @_;
		return $str if $arg != 1;
		my $plugin = MT->component('initHatenaIDnotation');

		my $blog_id = $ctx->stash('blog_id');
		my $service_setting = $plugin->get_config_value('initHatenaIDnotation', 'blog:'.$blog_id);
		my $link_target = $plugin->get_config_value('initHatenaIDnotation_link', 'blog:'.$blog_id);
		$str =~ s/(?:(d|b|f|h|blog):)?id:([a-zA-Z0-9\-\_]+)/&id_link($1, $2, $service_setting, $link_target)/ieg;
		return $str;
}

	sub id_link {
		my ($service, $id, $service_setting, $link_target) = @_;
		my $line;
		my $target;
		my %services = (
						 "Hatena profile" => "www",
						 "Diary"    => "d",
						 "Bookmark" => "b",
						 "Fotolife" => "f",
						 "Haiku"    => "h",
						 "Blog"     => "blog",
						);
		$id =~ s/[\x00-\x1F\x7F]//g;
		$target = $link_target eq 1 ? qq( target="_blank") : '';

		if($service){
				$line = "$service:";
		}elsif($service_setting){
				$service = $services{$service_setting};
		}

		$line = qq(<a href="http://$service.hatena.ne.jp/$id/"$target>$line\id:$id</a>);
		return $line;
}

1;
